      SUBROUTINE EF12R(SX,SY,N,M,A,U,F,P,P1,P2,P3,EPS,HX,W,L)
      DIMENSION SX(N),SY(M),A(M,N),U(N),F(M),P(M),H(50),W(N,8),HX(7)
      INTEGER N,M,L,I,J,K,NITER,IEXIT
      REAL SX,SY,A,U,F,P,P1,P2,P3,EPS,H,W,RMIN1,RMIN,R,F1,S,
     1SR,RR,HH,QQ,Q,H1
      RMIN1=1.
      GO TO (1,7,2),L
    1 RMIN=RMIN1
      RMIN1=RMIN/2.
      IF(RMIN1.GT.0.) GO TO 1
      CALL EFFR(A,M,N,P,SX,SY,F,P1,P2,P3,W(1,1),W(1,2),W(1,3),H)
      CALL EFRS(A,M,N,W(1,1),W(1,2),W(1,3),H)
      CALL EFUS(A,M,N,W(1,4),W(1,5),H)
      W(N,3)=RMIN
      GO TO 6
    2 DO 3  I=1,M
      F(I)=F(I)*P(I)
    3 CONTINUE
    6 CALL EFUF(A,M,N,F,H)
    7 RMIN=W(N,3)
      RMIN1=RMIN+RMIN
      F1=F(1)
      R=F1*F1
      S=(F1*W(1,4))**2
      DO 8 I=2,N
      F1=F(I)
      R=R+F1*F1
    8 S=S+(W(I,4)*F1+W(I-1,5)*F(I-1))**2
      SR=SQRT(R)
      RR=SR*EPS
      H(1)=SR
      H(2)=0.
      H(3)=0.
      H(4)=R
      H(5)=1.E+18
      H(6)=0.
      H(7)=1.
      NITER=0
      IEXIT=-1
      HH=SR
      QQ=H(5)
      DO 9 I=1,N
    9 U(I)=0.
      IF(EPS.GE.1.) GO TO 14
      Q=(EPS/(1.-EPS))*(S/R)
      IF(Q.EQ.0.) Q=RMIN
   10 CONTINUE
      CALL EFSL(W(1,4),W(1,5),M,N,Q,F,U,H,W(1,6),W(1,7),W(1,8))
      H1=H(1)
      H(5)=Q
      H(6)=H(6)+1.
      H(7)=H1/SR
      IF(IEXIT.EQ.1) GO TO 13
      IF(HH.GE.H1) GO TO 11
      IEXIT=1
      Q=QQ
      GO TO 10
   11 IF(RR*1.001.GE.H1) GO TO 13
      IF(Q.LE.RMIN1) GO TO 13
      HH=H1
      QQ=Q
      S=0.
      DO 12 I=1,N
   12 S=S+U(I)*Q*W(I,8)
      R=(H1/RR-1.)*H1*(H1/S)
      IF(R.LE.0.5) NITER=NITER+1
      IF(R.LE.0.5.AND.H(6).GE.10..AND.NITER.GT.5) R=1.
      Q=Q/(1.+R)
      IF(Q.EQ.0.) Q=RMIN
      GO TO 10
   13 CALL EFUD(A,M,N,U,H)
      CALL EFRD(U,N,W(1,1),W(1,2),W(1,3),SX,H)
C      H(6)=H(6)+NITER*0.01
   14 DO 15 I=1,7
      HX(I)=H(I)
   15 CONTINUE
      RETURN
      END
